clear all
clc

N   = 50;
eps = 1e-12;


% We have two test cases
example = 2;

if example == 1
    display('Processing example 1')
    n = 100;
    % ***************** Example 1 ****************
    e = ones(n,1);
    A = spdiags([-e 2*e -e], -1:1, n,n);
    
elseif example == 2
    display('Processing example 2')
    n = 1000;
    % ***************** Example 2 ****************
    e = ones(n,1);
    A = spdiags([-0.25*e -0.5*e 2*e -0.5*e -0.25*e], -2:2, n,n);
else
    error('This example does not exist')
end




% Right-hand side b
b  = ones(n,1);

% Initial value x0
x0 = zeros(n,1);

% Exact solution by Matlab
x_exact = A\ b;


% ********************************************************
% Part a): Implementation of the gradient method

%[x_gradm, quots_gradm] = gradientmethod(A,b,x0,x_exact,N,eps);
%error = norm(x_exact-x_gradm)

% ********************************************************
% Part b): Implementation of the conjugate gradient method

%[x_cgm, quots_cgm]   = cgmethod(A,b,x0,x_exact,N,eps);
%error = norm(x_exact-x_cgm)


% ********************************************************
% Part c): Computation of rho_{grad} and rho_{cg} and
%          plot of the error

eigenvalues       = eig(A);








